CON
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000
        SDA = 25
        SCL = 24
obj
   LJP  : "Lukes_Quickies_002"                                             
   i2c  : "i2cObject"

var                                                                         
                                                          
   byte luke1[260]   '4 longs + 128 longs(512 bytes) + 128 longs(512 bytes)  (4 + 128 + 128 = 260)
                                        
pub go | i,j,k,temp,temp2
  LJP.start(12)                                                    
  LJP.TextXY(0,0)                                                  
  LJP.str(string("RTC.8583.SPIN.B.002        03/26/2007"))        
  LJP.Retrn                                                        

  luke1[4]:=%1010_0000   'last bit is r/w read=1 write=0
  luke1[5]:=%0000_0000   'control byte

  StartSequence
  waitcnt(clkfreq*1 + cnt)
  
  'SetMode

  LJP.clear
  
  ReadTime

''=============================================================
''=============================================================
Pub ReadTime | i,j,k,l
waitcnt(clkfreq/1000 + cnt)
repeat                                     

  i2c.i2cStart
    i2c.i2cwrite(luke1[4],8)        
    i2c.i2cwrite(1,8)           '<-starting address in the RTC to read
    i2c.i2cStart                '    if less than 8, one must loop enough to read 8
    i2c.i2cwrite(luke1[4]+1,8)  '    so, if seconds desired, set to 2, and loop from 0 to 6
    repeat j from 0 to 7        '<-loop for however many bytes you want to read    
      luke1[6+j]:=i2c.i2cread(0)
  i2c.i2cStop
  
  LJP.textXY(15,6)    
  repeat j from 3 to 0 step 1
    LJP.dec(((luke1[6+j]&%1111_0000)>>4)<#9)    
    LJP.dec((luke1[6+j]&%0000_1111)<#9)
    LJP.str(string(" "))

  waitcnt(clkfreq/100 + cnt)
''=============================================================
''=============================================================   
Pri SetMode | i,j,k,l
  LJP.textXY(0,2)
  LJP.str(string("Page Write "))

  k:=false
  repeat until k == true                                
    k := i2c.devicepresent(luke1[4])

  LJP.str(string("done "))     

  i2c.i2cStart                       
    i2c.i2cwrite(luke1[4],8)   'slave address %1010_0000       
    i2c.i2cwrite(%0000_0000,8) 'word address        
    i2c.i2cwrite(luke1[5],8)   'control byte        *Not BCD format
    i2c.i2cwrite(%0000_0000,8) 'tens,hundreths      **All these are BCD format
    i2c.i2cwrite(%0000_0000,8) 'seconds
    i2c.i2cwrite(%0000_1001,8) 'minutes
    i2c.i2cwrite(%0001_0010,8) 'hours
  i2c.i2cStop                        

  k:=false
  repeat until k == true                                
    k := i2c.devicepresent(luke1[4])                 

  LJP.str(string("done "))                         
''=============================================================
''=============================================================
Pri StartSequence
  LJP.str(string("Checking to see if the 8583 is..."))

  LJP.textXY(0,4)
  'geterrorcode
  waitcnt (4_00_000 + cnt)
  LJP.str(string("Init "))
  LJP.dec(i2c.init(SDA,SCL,false))
  LJP.Retrn
  LJP.str(string("Start "))
  LJP.dec(i2c.Start)
  LJP.Retrn  
  'geterrorcode
  waitcnt (4_00_000 + cnt)
  LJP.str(string("Testbus "))
  LJP.dec(i2c.testBus)

  'geterrorcode
  if i2c.devicePresent(luke1[4]) == true
    waitcnt (4_000_000 + cnt)

  LJP.textXY(33,1)
  LJP.str(string("present"))
''=============================================================
''=============================================================

    